import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.tree.*;


public class TreeExample2 extends JFrame {
  public TreeExample2() {
    super("ToolTipTreeExample");
    
    String[][] labels = {
               {"item 0", "0 tooltip"},     // 0
		       {"item 1", "1 tooltip"},     // 1
		       {"item 2", "2 tooltip"},     // 2
		       {"item 3", "3 tooltip"},     // 3
		       {"item 4", "4 tooltip"},     // 4
		      };
                                             
    ToolTipTreeNode[] nodes = new ToolTipTreeNode[labels.length];
    for (int i=0; i < nodes.length;i++) {
      nodes[i] = new ToolTipTreeNode(labels[i][0], labels[i][1]); 
    }
    nodes[0].add(nodes[1]);
    nodes[1].add(nodes[2]);
    nodes[1].add(nodes[3]);
    nodes[0].add(nodes[4]);
    JTree tree = new JTree( nodes[0] ){
      public String getToolTipText(MouseEvent evt) {
	if (getRowForLocation(evt.getX(), evt.getY()) == -1) return null;    
	TreePath curPath = getPathForLocation(evt.getX(), evt.getY());
	return ((ToolTipTreeNode)curPath.getLastPathComponent()).getToolTipText();
      }
    };
    tree.setToolTipText("");
    JScrollPane sp = new JScrollPane(tree);
    getContentPane().add(sp, BorderLayout.CENTER);
  }

  public static void main(String args[]) {
    TreeExample2 frame = new TreeExample2();
    frame.addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {System.exit(0);}
    });
    frame.setSize(300, 150);
    frame.setVisible(true);
  }
}

class ToolTipTreeNode extends DefaultMutableTreeNode {
    
    private String toolTipText;
    
    public ToolTipTreeNode(String label, String toolTipText) {
      super(label);
      this.toolTipText = toolTipText;
    }

    public String getToolTipText() {
      return toolTipText;
    }
  } 
